#ifndef __GCMODPLAY_H__
#define __GCMODPLAY_H__

// Modified by Francisco Muoz 'Hermes' (www.elotrolado.net) MAY 2008
// - 'manual_polling' is used to continous play (FALSE) or pause the songs when it finish (TRUE)

#include <gctypes.h>
#include "modplay/modplay.h"

#ifdef __cplusplus
   extern "C" {
#endif /* __cplusplus */

typedef struct _modsndbuf {
	u32 freq;
	u16 fmt;
	u32 chans;
	f32 samples;
	void *usr_data;
	void (*callback)(void *,u8 *,u32);
} MODSNDBUF;

typedef struct _modplay {
	MOD mod;
	BOOL playing,paused;
	BOOL bits,stereo,manual_polling; // note: manual polling TRUE is used to auto-pause the song when it finish. if it is FALSE the song play for always 
	u32 playfreq,numSFXChans;
	MODSNDBUF soundBuf;
} MODPlay;

void MODPlay_Init(MODPlay *mod);
s32 MODPlay_SetFrequency(MODPlay *mod,u32 freq);
void MODPlay_SetStereo(MODPlay *mod,BOOL stereo);
s32 MODPlay_SetMOD(MODPlay *mod,const void *mem);
void MODPlay_Unload(MODPlay *mod);
s32 MODPlay_AllocSFXChannels(MODPlay *mod,u32 sfxchans);
s32 MODPlay_Start(MODPlay *mod);
s32 MODPlay_Stop(MODPlay *mod);

// add by Hermes

/* void MODPlay_SetVolume(MODPlay *mod, s32 musicvolume, s32 sfxvolume)

Set the volume levels for the MOD music (call it after MODPlay_SetMOD())

mod: the MODPlay pointer

musicvolume: in range 0 to 64
sfxvolume: in range 0 to 64

*/

void MODPlay_SetVolume(MODPlay * mod, s32 musicvolume, s32 sfxvolume);

s32 MODPlay_TriggerNote(MODPlay *mod,u32 chan,u8 inst,u16 freq,u8 vol);
s32 MODPlay_Pause(MODPlay *mod,BOOL);

#ifdef __cplusplus
   }
#endif /* __cplusplus */

#endif
